#Region AutoIt3Wrapper directives section
#AutoIt3Wrapper_UseAnsi=Y
#AutoIt3Wrapper_Icon=icons/SSRInstaller.ico
#AutoIt3Wrapper_Outfile=SSRInstaller.exe
#AutoIt3Wrapper_Outfile_Type=exe
#AutoIt3Wrapper_Compression=3
#AutoIt3Wrapper_UseUpx=Y
#AutoIt3Wrapper_Res_Description=ScreenSaverRotatorInstaller
#AutoIt3Wrapper_Res_Fileversion=1.0.0.1
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_LegalCopyright=(C) 2008, Hank7
#AutoIt3Wrapper_Res_SaveSource=N
#AutoIt3Wrapper_Run_Before=%autoitdir%\autoit3a.exe "%scriptdir%\RunBefore.au3" %in%
#EndRegion AutoIt3Wrapper directives section

#cs ----------------------------------------------------------------------------
	AutoIt Version: 3.2.12.0
	Author: Hank7
	Script Function: Installer for ScreenSaverRotator
#ce ----------------------------------------------------------------------------

#NoTrayIcon

;$newversion = "x.x.x.x"
#include "SSRversion.au3"

;#include <GUIConstantsEx.au3>
Global Const $GUI_EVENT_CLOSE = -3
Global Const $GUI_CHECKED = 1


FileChangeDir(@ScriptDir)

$destination = @SystemDir & "\ScreenSaverRotator.scr"
$oldversion = FileGetVersion($destination)
$replace = 0

If @OSLang = "0407" Or "0807" Or "0c07" Or "1007" Or "1407" Then
	$ML_Title = "ScreenSaverRotator Setup"
	$ML_DefaultScreensaver = "Als Bildschirmschoner benutzen"
	$ML_Install = "ScreenSaverRotator " & $newversion & " installieren"
	$ML_Repair = "ScreenSaverRotator " & $newversion & " reparieren"
	$ML_Exit = "Setup beenden"
	$ML_TermsHeader = "Lizenzbedingungen:"
	$ML_TermsOfLicense = "ScreenSaverRotator kann ohne Einschrnkungen auf eigene Gefahr benutzt" & @CRLF & "und weitergegeben werden. Der Urheber dieser Software ist nicht fr dadurch" & @CRLF & "verursachte Schden verantwortlich. Wenn Sie diese Software benutzen," & @CRLF & "akzeptieren Sie die Lizenzbedingungen."
	$ML_Copyright = "ScreenSaverRotator (C) 2008, Hank7"
	$ML_AcceptTerms = "Akzeptieren Sie die Lizenzbedingungen?"
	$ML_AlreadyInstalled = "ScreenSaverRotator " & $oldversion & " ist bereits installiert." & @CRLF & "Mchten Sie es mit der lteren Version " & $newversion & " ersetzen?"
	$ML_Error = "Fehler. Konnte" & @CRLF & $destination & @CRLF & "nicht installieren."
	$ML_Success = "ScreenSaverRotator wurde erfolgreich installiert."
	$ML_AdminRights = "Sie mssen als Administrator angemeldet sein, um ScreenSaverRotator zu installierern."
Else
	$ML_Title = "ScreenSaverRotator Setup"
	$ML_DefaultScreensaver = "Set as default screensaver"
	$ML_Install = "Install ScreenSaverRotator " & $newversion
	$ML_Repair = "Repair ScreenSaverRotator " & $newversion
	$ML_Exit = "Exit Setup"
	$ML_TermsHeader = "Terms of License:"
	$ML_TermsOfLicense = "ScreenSaverRotator is free to use and distribute for anyone at own risk." & @CRLF & "The creator of this software is not responsible for any harm done by it." & @CRLF & "By using this software you accept the terms of license."
	$ML_Copyright = "ScreenSaverRotator (C) 2008, Hank7"
	$ML_AcceptTerms = "Do you accept the terms of license?"
	$ML_AlreadyInstalled = "ScreenSaverRotator " & $oldversion & " is already installed." & @CRLF & "Do you want to replace it with the older version " & $newversion & "?"
	$ML_Error = "Error. Could not install" & @CRLF & $destination & "."
	$ML_Success = "ScreenSaverRotator was successfully installed."
	$ML_AdminRights = "You need administrator rights to install ScreenSaverRotator."
Endif


FileInstall("setup.gif", @TempDir & "\ScreenSaverRotatorSetup.gif", 0)

GUICreate($ML_Title, 360, 130)
Opt("GUICoordMode", 1)

GUICtrlCreatePic(@TempDir & "\ScreenSaverRotatorSetup.gif", 0, 0, 130, 130)

If IsAdmin() Then

	$CHB_default = GUICtrlCreateCheckbox($ML_DefaultScreensaver, 140, 10, 210, 30)
	GUICtrlSetState($CHB_default, $GUI_CHECKED)
	If _VersionValue($oldversion) = _VersionValue($newversion) Then
		$BUT_install = GUICtrlCreateButton($ML_Repair, 140, 50, 210, 30)
	Else
		$BUT_install = GUICtrlCreateButton($ML_Install, 140, 50, 210, 30)
	EndIf
	$BUT_exit = GUICtrlCreateButton($ML_Exit, 140, 90, 210, 30)
	GUISetState()

	While 1
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE Or $msg = $BUT_exit
				ExitLoop
			Case $msg = $BUT_install
				$MSB_license = MsgBox(262180, $ML_Title, $ML_TermsHeader & @CRLF & @CRLF & $ML_TermsOfLicense & @CRLF & @CRLF & $ML_Copyright & @CRLF & @CRLF & $ML_AcceptTerms)
				If $MSB_license = 6 Then
					If FileExists($destination) Then
						If _VersionValue($oldversion) > _VersionValue($newversion) Then
							$MSB_replace = MsgBox(262177, $ML_Title, $ML_AlreadyInstalled)
							If $MSB_replace = 1 Then
								$replace = 1
							ElseIf $MSB_replace = 2 Then
								$replace = 0
							EndIf
						Else
							$replace = 1
						EndIf
					EndIf
					If FileInstall("ScreenSaverRotator.scr", $destination, $replace) = 0 Then
						MsgBox(262160, $ML_Title, $ML_Error)
					Else
						If GUICtrlRead($CHB_default, 0) = $GUI_CHECKED Then
							$display = Run("rundll32.exe desk.cpl,InstallScreenSaver " & $destination)
							Sleep(350)
							Run($destination & " /c")
						EndIf
						MsgBox(262208, $ML_Title, $ML_Success)
						ExitLoop
					EndIf
				EndIf
		EndSelect
	WEnd
	
Else
	
	GUICtrlCreateLabel($ML_AdminRights, 140, 10, 210, 70)
	$BUT_exit = GUICtrlCreateButton($ML_Exit, 140, 90, 210, 30)
	
	GUISetState()

	While 1
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE Or $msg = $BUT_exit
				ExitLoop
		EndSelect
	WEnd

EndIf

FileDelete(@TempDir & "\ScreenSaverRotatorSetup.gif")

Exit


Func _VersionValue($version)
	Local $array = StringSplit($version, ".")
	Return $array[1] * 1000000000 + $array[2] * 1000000 + $array[3] * 1000 + $array[4]
EndFunc   ;==>_VersionValue