#Region AutoIt3Wrapper directives section
#AutoIt3Wrapper_UseAnsi=Y
#AutoIt3Wrapper_Icon=icons/ScreenSaverRotator.ico
#AutoIt3Wrapper_Outfile=ScreenSaverRotator.exe ;Rename to .scr later!
#AutoIt3Wrapper_Outfile_Type=exe
#AutoIt3Wrapper_Compression=3
#AutoIt3Wrapper_UseUpx=Y
#AutoIt3Wrapper_Res_Description=ScreenSaverRotator
#AutoIt3Wrapper_Res_Fileversion=1.0.0.1
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_LegalCopyright=(C) 2008, Hank7
#AutoIt3Wrapper_Res_SaveSource=N
#AutoIt3Wrapper_Run_Before=%autoitdir%\autoit3a.exe "%scriptdir%\RunBefore.au3" %in%
#AutoIt3Wrapper_Run_After=%autoitdir%\autoit3a.exe "%scriptdir%\RunAfter.au3" %out%
#EndRegion AutoIt3Wrapper directives section

#cs ----------------------------------------------------------------------------
	AutoIt Version: 3.2.12.0
	Author: Hank7
	Script Function: ScreenSaverRotator
#ce ----------------------------------------------------------------------------


#NoTrayIcon

;#include <GUIConstantsEx.au3>
Global Const $GUI_EVENT_CLOSE = -3
Global Const $GUI_CHECKED = 1
Global Const $GUI_UNCHECKED = 4
Global Const $GUI_DROPACCEPTED = 8
;#include <WindowsConstants.au3>
Global Const $WS_EX_ACCEPTFILES = 0x00000010


FileChangeDir(@ScriptDir)

If FileExists(StringTrimRight(FileGetLongName(@AutoItExe), 4) & ".ini") Then
	$SettingsFile = StringTrimRight(FileGetLongName(@AutoItExe), 4) & ".ini"
	$LanguageFile = StringTrimRight(FileGetLongName(@AutoItExe), 4) & ".lng"
Else
	DirCreate(@AppDataDir & "\ScreenSaverRotator")
	$SettingsFile = @AppDataDir & "\ScreenSaverRotator\ScreenSaverRotator.ini"
	$LanguageFile = @AppDataDir & "\ScreenSaverRotator\ScreenSaverRotator.lng"
EndIf

FileInstall("default.ini", $SettingsFile, 0)

If IniRead($SettingsFile, "Settings", "language", "unknown") = "unknown" Then
	If @OSLang = "0407" Or "0807" Or "0c07" Or "1007" Or "1407" Then
		IniWrite($SettingsFile, "Settings", "language", "german")
	Else
		IniWrite($SettingsFile, "Settings", "language", "english")
	EndIf
EndIf

If IniRead($SettingsFile, "Settings", "language", "english") = "german" Then
	$ML_Randomize = "Zufllig"
	$ML_Add = "Hinzufgen"
	$ML_Save = "Speichern"
	$ML_Exit = "Beenden"
	$ML_AddScreensaver = "Bildschirmschoner zur Liste hinzufgen"
	$ML_Screensaver = "Bildschirmschoner"
	$ML_AllFiles = "Alle Dateien"
Else
	$ML_Randomize = "Randomize"
	$ML_Add = "Add"
	$ML_Save = "Save"
	$ML_Exit = "Exit"
	$ML_AddScreensaver = "Add a screensaver to the list"
	$ML_Screensaver = "Screensaver"
	$ML_AllFiles = "All Files"
EndIf

If FileExists($LanguageFile) Then
	$ML_Randomize = IniRead($LanguageFile, "Text", "Randomize", "Randomize")
	$ML_Add = IniRead($LanguageFile, "Text", "Add", "Add")
	$ML_Save = IniRead($LanguageFile, "Text", "Save", "Save")
	$ML_Exit = IniRead($LanguageFile, "Text", "Exit", "Exit")
	$ML_AddScreensaver = IniRead($LanguageFile, "Text", "AddScreensaver", "Add a screensaver to the list")
	$ML_Screensaver = IniRead($LanguageFile, "Text", "Screensaver", "Screensaver")
	$ML_AllFiles = IniRead($LanguageFile, "Text", "AllFiles", "All Files")
EndIf

If IniRead($SettingsFile, "Screensaver", "1", "error") = "error" Then
	IniWrite($SettingsFile, "Screensaver", "1", "black")
EndIf

$current = IniRead($SettingsFile, "Settings", "next", "1")
$keys = IniReadSection($SettingsFile, "Screensaver")
If $current > $keys[0][0] Then
	$current = 1
EndIf
$screensaver = StringSplit(IniRead($SettingsFile, "Screensaver", $current, ""), "|")

If StringLeft($CmdLineRaw, 2) = "/c" Or $CmdLineRaw = "" Then ;Configure screensaver

	$configure = GUICreate("ScreenSaverRotator", 440, 360, -1, -1, -1, $WS_EX_ACCEPTFILES)
	Opt("GUICoordMode", 1)
	
	$ssList = ""
	For $ssID = 1 To $keys[0][0]
		If $ssID = $keys[0][0] Then
			$LineEnd = ""
		Else
			$LineEnd = @CRLF
		EndIf
		$ssList = $ssList & IniRead($SettingsFile, "Screensaver", $ssID, "") & $LineEnd
	Next
	$EDI_screensavers = GUICtrlCreateEdit($ssList, 10, 10, 420, 300)
	GUICtrlSetState($EDI_screensavers, $GUI_DROPACCEPTED)
	$CHB_random = GUICtrlCreateCheckbox($ML_Randomize, 10, 320, 90, 30)
	$BUT_add = GUICtrlCreateButton($ML_Add, 110, 320, 100, 30)
	$BUT_save = GUICtrlCreateButton($ML_Save, 220, 320, 100, 30)
	$BUT_exit = GUICtrlCreateButton($ML_Exit, 330, 320, 100, 30)
	If IniRead($SettingsFile, "Settings", "random", "no") = "yes" Then
		GUICtrlSetState($CHB_random, $GUI_CHECKED)
	Else
		GUICtrlSetState($CHB_random, $GUI_UNCHECKED)
	EndIf
	GUISetState()

	While 1
		$msg = GUIGetMsg()
		Select
			Case $msg = $GUI_EVENT_CLOSE Or $msg = $BUT_exit
				ExitLoop
			Case $msg = $BUT_add
				$initDir = IniRead($SettingsFile, "Settings", "MRU", @ScriptDir)
				$newSS = FileOpenDialog($ML_AddScreensaver, $initDir, $ML_Screensaver & " (*.scr)|" & $ML_AllFiles & " (*.*)", 3, "", $configure)
				If Not $newSS = "" Then
					GUICtrlSetData($EDI_screensavers, GUICtrlRead($EDI_screensavers, 0) & @CRLF & $newSS)
					$getPath = StringSplit($newSS, "\")
					$initDir = ""
					For $layer = 1 To $getPath[0] - 1
						$initDir = $initDir & $getPath[$layer] & "\"
					Next
					IniWrite($SettingsFile, "Settings", "MRU", $initDir)
				EndIf
				FileChangeDir(@ScriptDir)
			Case $msg = $BUT_save
				If GUICtrlRead($CHB_random, 0) = $GUI_CHECKED Then
					IniWrite($SettingsFile, "Settings", "random", "yes")
				Else
					IniWrite($SettingsFile, "Settings", "random", "no")
				EndIf
				$LineCount = StringSplit(GUICtrlRead($EDI_screensavers, 0), @CRLF, 1)
				$key = 0
				IniDelete($SettingsFile, "Screensaver")
				For $ssID = 1 To $LineCount[0]
					If $LineCount[$ssID] = "" Then
						$key = $key
					Else
						$key = $key + 1
						IniWrite($SettingsFile, "Screensaver", $key, $LineCount[$ssID])
					EndIf
				Next
		EndSelect
	WEnd

	Exit
	
ElseIf StringLeft($CmdLineRaw, 2) = "/p" Then ;Preview screensaver
	
	If FileExists($screensaver[1]) And StringRight($screensaver[1], 4) = ".scr" Then
		RunWait($screensaver[1] & " " & $CmdLineRaw)
	EndIf
	Exit
	
ElseIf StringLeft($CmdLineRaw, 2) = "/s" Then ;Start screensaver
	
	If FileExists($screensaver[1]) Then
		If StringRight($screensaver[1], 4) = ".scr" Then
			RunWait($screensaver[1] & " /s")
		ElseIf StringRight($screensaver[1], 4) = ".exe" Or StringRight($screensaver[1], 4) = ".bat" Or StringRight($screensaver[1], 4) = ".com" Then
			If $screensaver[0] = 1 Then
				RunWait($screensaver[1])
			Else
				RunWait($screensaver[1] & " " & $screensaver[2])
			EndIf
		Else
			ShellExecute($screensaver[1])
		EndIf
	ElseIf $screensaver[1] = "black" Then ;Screensaver list variable "black": Show a black screen
		$black = GUICreate("Black Screen", @DesktopWidth + 100, @DesktopHeight + 100)
		Opt("GUICoordMode", 1)
		GUISetBkColor(0x000000, $black)
		$button = GUICtrlCreateButton("", 0, 0, @DesktopWidth + 100, @DesktopHeight + 100)
		GUICtrlSetBkColor($button, 0x000000)
		GUICtrlSetCursor($button, 16)
		GUISetState()
		While 1
			$msg = GUIGetMsg()
			$msg2 = GUIGetMsg(1)
			If $msg = $GUI_EVENT_CLOSE Then ExitLoop
			If $msg = $button Then ExitLoop
			If $msg2[3] = True Then ExitLoop
			If $msg2[4] = True Then ExitLoop
		WEnd
		
	ElseIf $screensaver[1] = "monitor" Then ;Screensaver list variable "monitor": Shutdown the monitor
		_Monitor()
	EndIf

	If IniRead($SettingsFile, "Settings", "random", "no") = "yes" Then
		IniWrite($SettingsFile, "Settings", "next", Random(1, $keys[0][0], 1))
	Else
		If $current + 1 > $keys[0][0] Then
			IniWrite($SettingsFile, "Settings", "next", "1")
		Else
			IniWrite($SettingsFile, "Settings", "next", $current + 1)
		EndIf
	EndIf
	
EndIf

Func _Monitor($OnOff = 0)
	Local $opt = Opt("WinTitleMatchMode", 4)
	Local $opt
	If $OnOff = 0 Then
		$Param = 2
	Else
		$Param = -1
	EndIf
	DllCall("user32.dll", "int", "SendMessage", "hwnd", WinGetHandle("classname=Progman"), "int", 274, "int", 61808, "int", $Param)
	Opt("WinTitleMatchMode", $opt)
EndFunc   ;==>_Monitor